package org.toilelibre.libe.ratrap.shared;

import java.io.Serializable;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

public class Station implements Serializable, LocalizedPlace {

    /**
   * 
   */
    private static final long serialVersionUID = 2055728007310596061L;
    private Set<String>       aliases;
    private City              city;
    private List<Line>        connections;
    private int               id;
    private String            name;

    private Position          position;

    public Station () {
        super ();
        this.connections = new LinkedList<Line> ();
        this.aliases = new HashSet<String> ();
    }

    public void addAlias (final String string) {
        this.aliases.add (string);
    }

    public Set<String> getAliases () {
        return this.aliases;
    }

    public City getCity () {
        return this.city;
    }

    public List<Line> getConnections () {
        return this.connections;
    }

    public int getId () {
        return this.id;
    }

    public String getName () {
        return this.name;
    }

    @Override
    public Position getPosition () {
        return this.position;
    }

    public void setCity (final City city) {
        this.city = city;
    }

    public void setConnections (final List<Line> connections) {
        this.connections = connections;
    }

    public void setId (final int id) {
        this.id = id;
    }

    public void setName (final String name) {
        this.name = name;
    }

    public void setPosition (final Position position) {
        this.position = position;
    }

    @Override
    public String toString () {
        return this.name + ", " + this.city + " " + this.connections + " " + this.position;
    }
}
