package org.toilelibre.libe.ratrap.shared;

import java.io.Serializable;

public enum TransportType implements Serializable {

    Bus ("bus", "(BUS)"), Metro ("metro", "(M)"), RER ("rer", "(RER)"), Tramway ("tramway", "(T)"), Transilien ("transilien", "/T/ SNCF ");

    public static TransportType getByValue (final String value) {
        for (final TransportType tp : TransportType.values ()) {
            if (tp.value.toUpperCase ().equals (value.toUpperCase ())) {
                return tp;
            }
        }
        return null;
    }

    private String display;
    private String value;

    TransportType (final String value1, final String display1) {
        this.value = value1;
        this.display = display1;
    }

    @Override
    public String toString () {
        return this.display;
    }
}
